----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Timer is
    Port ( Clk : 				in  STD_LOGIC;
           interrupt_ack : in  STD_LOGIC;
			  T_Scale:        in  STD_LOGIC_VECTOR( 7 DOWNTO 0);
           interrupt : 		out STD_LOGIC);
end Timer;

architecture Behavioral of Timer is
	signal timer_count: 	integer range 0 to 500000 :=0;
	signal Max_count:		integer range 0 to 500000 :=0;
	signal timer_pulse: 	std_logic;   
begin
   with T_Scale select
      Max_Count <= 500000 when "00000001",
	                 50000 when "00000010",
	                  5000 when "00000011",
	                   500 when "00000100",
                       50 when others;					 
  ----------------------------------------------------------------------------------
  -- Interrupt is a generated once every ??? clock cycles to provide a ?us reference. 
  -- Interrupt is automatically cleared by interrupt acknowledgment from KCPSM3.
  Timer: process(clk)
  begin
    if clk'event and clk='1' then    
      if timer_count= Max_count then 
         timer_count <=  1;
         timer_pulse <= '1';
       else
         timer_count <= timer_count + 1;
         timer_pulse <= '0';
      end if;

      if interrupt_ack = '1' then
         interrupt <= '0';
       elsif timer_pulse = '1' then 
         interrupt <= '1';
      end if;   
    end if;
    
  end process Timer;

end Behavioral;

